#!/usr/bin/python
####################################################################################################
#
#	Author:		Konrad Rzeszutek, Joshua Nicholas
#
"""Utilities for forking.
"""

import os
import sys
import time

__all__ = [	'vi_fork',
			'vi_close_fds' ]

def vi_fork():
	"""
	Fork a double-child.
	"""
	pid = os.fork()

	if pid != 0:
		os.waitpid(pid, 0)
		# Parent exit
		return pid

	os.setsid()
	pid = os.fork()
	if pid != 0:
		# Child #1 exit.
		os._exit(0)

	# Child #2
	os.chdir("/")
	os.umask(0)
	return pid

def vi_close_fds(except_fd_LIST):
	"""
	Close all of the file descriptors, except the ones on the passed in list.
	"""
	for fd in range(0, 1024):
		if fd not in except_fd_LIST:
			try:
				os.close(fd)
			except:
				pass

	os.open("/dev/null", os.O_RDWR)
	os.dup2(0, 1)
	os.dup2(0, 1)

