#!/usr/bin/python
####################################################################################################
#
#	Author:		Joshua Nicholas
#
"""Utilities for helping with deal with time
"""

import datetime
import time

####################################################################################################

__all__ = [	'VI_DATETIME_ZERO'
		,	'VI_DATETIME_HOUR'
		,	'VI_UTC'
		,	'vi_calc_delta_time'
		,	'vi_delta_time_to_now' ]

####################################################################################################

VI_DATETIME_ZERO	= datetime.timedelta( 0 )
VI_DATETIME_HOUR	= datetime.timedelta( hours=1 )

class VI_UTC(datetime.tzinfo):		# Why Oh WHY is this not included for free ???
    """UTC"""

    def utcoffset( self, dt ):
        return VI_DATETIME_ZERO

    def tzname( self, dt ):
        return "UTC"

    def dst( self, dt ):
        return VI_DATETIME_HOUR

####################################################################################################
def vi_calc_delta_time( begTimeInSecs, endTimeInSecs ):
	"""
	This routine
	"""
#
	if endTimeInSecs >= begTimeInSecs:
		return endTimeInSecs - begTimeInSecs
	return     begTimeInSecs - endTimeInSecs

####################################################################################################
def vi_delta_time_to_now( begTimeInSecs ):
	"""
	This routine
	"""
#
	return vi_calc_delta_time( begTimeInSecs, time.time() )

####################################################################################################
# END
